package it.dsestili.jhash.gui;

/*
JHash a simple hash code generator
Copyright (C) 2013 Davide Sestili

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

import it.dsestili.jhash.core.Utils;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EmptyBorder;
import javax.swing.JTable;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

@SuppressWarnings("serial")
public class HashListWindow extends JDialog 
{
	private final JPanel contentPanel = new JPanel();
	private JScrollPane scrollPane;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) 
	{
		try 
		{
			HashListWindow dialog = new HashListWindow(null, null);
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} 
		catch(Exception e) 
		{
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public HashListWindow(final Frame frame, final Vector<Vector<String>> hashList) 
	{
		super(frame, true);

		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		
		setTitle("Hash List");
		setBounds(100, 100, 396, 470);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(new BorderLayout(0, 0));
		{
			Vector<String> columnNames = new Vector<String>();
			columnNames.add("File");
			columnNames.add("Hash");
			
			JTable table = new JTable(hashList, columnNames);
			
			scrollPane = new JScrollPane(table);

			contentPanel.add(scrollPane, BorderLayout.CENTER);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) 
					{
						dispose();
					}
				});
				{
					JButton btnSaveToFile = new JButton("Save to file");
					btnSaveToFile.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent arg0) 
						{
							try 
							{
								Utils.saveHashToFile(frame, hashList);
							} 
							catch(Throwable e) 
							{
								JOptionPane.showMessageDialog(null, "Error occurred", "Error occurred", JOptionPane.ERROR_MESSAGE);
								
								e.printStackTrace();
							}
						}
					});
					buttonPane.add(btnSaveToFile);
				}
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
		}
		
		setSize(800, 600);
		MainWindow.centerScreen(this);
		setVisible(true);		
	}

}
